Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -1139,6 +1724,4 @@
             SubDirectory => {
                 TagTable => 'Image::ExifTool::Nikon::ShotInfoD700',
-                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
-                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
                 DecryptStart => 4,
                 DecryptLen => 0x358,
@@ -1146,4 +1729,39 @@
             },
         },
+        { #PH (D800 firmware 1.01a)
+            Condition => '$$valPt =~ /^0222/',
+            Name => 'ShotInfoD800',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD800',
+                DecryptStart => 4,
+                DecryptLen => 0x720,
+                ByteOrder => 'BigEndian',
+            },
+        },
+        { #28 (D810 firmware 1.01)
+            Condition => '$$valPt =~ /^0233/',
+            Name => 'ShotInfoD810',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD810',
+                DecryptStart => 4,
+                DecryptLen => 0x36f4 + 12,
+                DecryptMore => 'Get32u(\$data, 0x84) + 12',
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        { #28 (D850 firmware 1.00b)
+            Condition => '$$valPt =~ /^0243/',
+            Name => 'ShotInfoD850',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD850',
+                DecryptStart => 4,
+                DecryptLen => 0x2efb + 12,
+                DecryptMore => 'Get32u(\$data, 0xa0) + 12',
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        # 0217 - D3000
+        # 0219 - D3100
+        # 0224 - D3200
         { #PH
             Condition => '$$valPt =~ /^0215/ and $count == 6745',
@@ -1156,4 +1774,24 @@
             },
         },
+        { #PH
+            Condition => '$$valPt =~ /^0221/ and $count == 8902',
+            Name => 'ShotInfoD5100',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD5100',
+                DecryptStart => 4,
+                DecryptLen => 0x430,
+                ByteOrder => 'BigEndian',
+            },
+        },
+        { #PH
+            Condition => '$$valPt =~ /^0226/ and $count == 11587',
+            Name => 'ShotInfoD5200',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD5200',
+                DecryptStart => 4,
+                DecryptLen => 0xd00,
+                ByteOrder => 'BigEndian',
+            },
+        },
         { #29 (D7000 firmware version 1.01b)
             Condition => '$$valPt =~ /^0220/',
@@ -1161,6 +1799,4 @@
             SubDirectory => {
                 TagTable => 'Image::ExifTool::Nikon::ShotInfoD7000',
-                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
-                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
                 DecryptStart => 4,
                 DecryptLen => 0x448,
@@ -1168,6 +1804,78 @@
             },
         },
-        {
-            Condition => '$$valPt =~ /^02/',
+        { # (D4 firmware version 1.00g)
+            Condition => '$$valPt =~ /^0223/',
+            Name => 'ShotInfoD4',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD4',
+                DecryptStart => 4,
+                DecryptLen => 0x789,
+                ByteOrder => 'BigEndian',
+            },
+        },
+        { # (D4S firmware version 1.00d and 1.01a)
+            Condition => '$$valPt =~ /^0231/',
+            Name => 'ShotInfoD4S',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD4S',
+                DecryptStart => 4,
+                DecryptLen => 0x3697,
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        { #28 (D5 firmware version 1.10a)
+            Condition => '$$valPt =~ /^0238/',
+            Name => 'ShotInfoD5',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD500',
+                DecryptStart => 4,
+                DecryptLen => 0x2c24 + 12,
+                DecryptMore => 'Get32u(\$data, 0xa8) + 0x2ea5 - 0x2c90',
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        { # (D500 firmware version 1.00)
+            Condition => '$$valPt =~ /^0239/',
+            Name => 'ShotInfoD500',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD500',
+                DecryptStart => 4,
+                DecryptLen => 0x2cb2 + 4,
+                DecryptMore => 'Get32u(\$data, 0xa8) + 0x2ea5 - 0x2c90',
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        { # (D6 firmware version 1.00, ref 28)
+            Condition => '$$valPt =~ /^0246/',
+            Name => 'ShotInfoD6',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD6',
+                DecryptStart => 4,
+                DecryptLen => 0xc21a + 12,
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        { # (D610 firmware version 1.00)
+            Condition => '$$valPt =~ /^0232/',
+            Name => 'ShotInfoD610',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoD610',
+                DecryptStart => 4,
+                DecryptLen => 0x7ff,
+                ByteOrder => 'BigEndian',
+            },
+        },
+        { # (Z6_2 firmware version 1.00 and Z7_2 firmware versions 1.00 & 1.01, ref 28)
+            Condition => '$$valPt =~ /^0800/ or $$valPt =~ /^0803/',
+            Name => 'ShotInfoZ7_2',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ShotInfoZ7_2',
+                DecryptStart => 4,
+                DecryptLen => 0xce32 + 12,
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        { # D7100=0227, Z6/Z7=0800
+            Condition => '$$valPt =~ /^0[28]/',
             Name => 'ShotInfo02xx',
             SubDirectory => {
@@ -1202,17 +1910,23 @@
             3 => 'Lossless',
             4 => 'Lossy (type 2)',
-        },
-    },
-    0x0094 => { Name => 'Saturation',       Writable => 'int16s' },
-    0x0095 => { Name => 'NoiseReduction',   Writable => 'string' },
+            5 => 'Striped packed 12 bits', #IB
+            6 => 'Uncompressed (reduced to 12 bit)', #IB
+            7 => 'Unpacked 12 bits', #IB (padded to 16)
+            8 => 'Small', #IB
+            9 => 'Packed 12 bits', #IB (2 pixels in 3 bytes)
+            10 => 'Packed 14 bits', #28 (4 pixels in 7 bytes, eg. D6 uncompressed 14 bit)
+        },
+    },
+    0x0094 => { Name => 'SaturationAdj',    Writable => 'int16s' },
+    0x0095 => { Name => 'NoiseReduction',   Writable => 'string' }, # ("Off" or "FPNR"=long exposure NR)
     0x0096 => {
-        Name => 'LinearizationTable', # same table as DNG LinearizationTable (ref JD)
-        Writable => 0,
-        Binary => 1,
+        Name => 'NEFLinearizationTable', # same table as DNG LinearizationTable (ref JD)
+        Writable => 'undef',
+        Flags => [ 'Binary', 'Protected' ],
     },
     0x0097 => [ #4
         # (NOTE: these are byte-swapped by NX when byte order changes)
         {
-            Condition => '$$valPt =~ /^0100/', # (D100)
+            Condition => '$$valPt =~ /^0100/', # (D100 and Coolpix models)
             Name => 'ColorBalance0100',
             SubDirectory => {
@@ -1230,5 +1944,5 @@
         },
         {
-            Condition => '$$valPt =~ /^0103/', # (D70)
+            Condition => '$$valPt =~ /^0103/', # (D70/D70s)
             Name => 'ColorBalance0103',
             # D70:  at file offset 'tag-value + base + 20', 4 16 bits numbers,
@@ -1251,6 +1965,6 @@
             },
         },
-        {
-            Condition => '$$valPt =~ /^0209/', # (D3)
+        {   # (D3/D3X/D300/D700=0209,D300S=0212,D3S=0214)
+            Condition => '$$valPt =~ /^02(09|12|14)/',
             Name => 'ColorBalance0209',
             SubDirectory => {
@@ -1259,9 +1973,9 @@
                 WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
                 DecryptStart => 284,
-                DecryptLen => 18, # don't need to decrypt it all
+                DecryptLen => 18, # 324 bytes encrypted, but don't need to decrypt it all
                 DirOffset => 10,
             },
         },
-        {   # (D2X=0204,D2Hs=0206,D200=0207,D40=0208)
+        {   # (D2X/D2Xs=0204,D2Hs=0206,D200=0207,D40/D40X/D80=0208,D60=0210)
             Condition => '$$valPt =~ /^02(\d{2})/ and $1 < 11',
             Name => 'ColorBalance02',
@@ -1271,11 +1985,68 @@
                 WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
                 DecryptStart => 284,
-                DecryptLen => 14, # 324 bytes encrypted, but don't need to decrypt it all
+                DecryptLen => 14, # don't need to decrypt it all
                 DirOffset => 6,
             },
         },
-        {   # (D90/D5000=0211,D300S=0212,D3000=0213,D3S=0214,D3100=0215,D7000/D5100=0216)
+        {
+            Condition => '$$valPt =~ /^0211/', # (D90/D5000)
+            Name => 'ColorBalance0211',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalance4',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 284,
+                DecryptLen => 24, # don't need to decrypt it all
+                DirOffset => 16,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^0213/', # (D3000)
+            Name => 'ColorBalance0213',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalance2',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 284,
+                DecryptLen => 18, # don't need to decrypt it all
+                DirOffset => 10,
+            },
+        },
+        {   # (D3100=0215,D7000/D5100=0216,D4/D600/D800/D800E/D3200=0217)
+            Condition => '$$valPt =~ /^021[567]/',
+            Name => 'ColorBalance0215',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalance4',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 284,
+                DecryptLen => 12, # don't need to decrypt it all
+                DirOffset => 4,
+            },
+        },
+        {   # (D5200/D7100=0218, D5300=0219, D610/Df=0220, D3300=0221, CoolpixA=0601)
+            Name => 'ColorBalanceUnknown02',
+            Condition => '$$valPt =~ /^0[26]/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalanceUnknown',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 284,
+                DecryptLen => 10, # (arbitrary)
+            },
+        },
+        {   # (1J1/1J2/1V1=0400, 1V2=0401, 1J3/1S1=0402, 1AW1=0403, Z6/Z7=0800)
+            Name => 'ColorBalanceUnknown04',
+            Condition => '$$valPt =~ /^0[48]/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::ColorBalanceUnknown',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+                DecryptLen => 10, # (arbitrary)
+            },
+        },
+        {
+            # (CoolpixP7700/P7800=0500, CoolpixP330/P520=0502)
             Name => 'ColorBalanceUnknown',
-            Writable => 0,
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::ColorBalanceUnknown' },
         },
     ],
@@ -1316,7 +2087,51 @@
         },
         {
+            Condition => '$$valPt =~ /^040[01]/', # 0=1J1/1V1, 1=1J2
+            Name => 'LensData0400',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0400',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^0402/', # 1J3/1S1/1V2
+            Name => 'LensData0402',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0402',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^0403/', # 1J4,1J5
+            Name => 'LensData0403',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0403',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+            },
+        },
+        {
+            Condition => '$$valPt =~ /^080[01]/', # Z6/Z7
+            Name => 'LensData0800',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Nikon::LensData0800',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
+                ByteOrder => 'LittleEndian',
+            },
+        },
+        {
             Name => 'LensDataUnknown',
             SubDirectory => {
                 TagTable => 'Image::ExifTool::Nikon::LensDataUnknown',
+                ProcessProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                WriteProc => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+                DecryptStart => 4,
             },
         },
@@ -1340,6 +2155,20 @@
         # Landscape Assist:LANDSCAPE,SCENIC VIEW,ARCHITECTURE,GROUP RIGHT,GROUP LEFT
         # Sports Assist:   SPORTS,SPORT SPECTATOR,SPORT COMPOSITE
+        # P7100 has test modes: - PH
+        #  CREATIVE MONOCHROME,PAINTING,CROSS PROCESS,SOFT,NOSTALGIC SEPIA,
+        #  HIGH KEY,LOW KEY,SELECTIVE COLOR,ZOOM EXPOSURE EXP.,DEFOCUS DURING
         Name => 'SceneAssist',
         Writable => 'string',
+    },
+    0x009d => { #NealKrawetz
+        Name => 'DateStampMode',
+        Writable => 'int16u',
+        Notes => 'feature to imprint date/time on image',
+        PrintConv => { #PH
+            0 => 'Off',
+            1 => 'Date & Time',
+            2 => 'Date',
+            3 => 'Date Counter', # (NC) (D3500)
+        },
     },
     0x009e => { #JD
@@ -1386,7 +2215,11 @@
         Writable => 'int32u',
         Protected => 1,
+        PrintConv => '$val == 4294965247 ? "n/a" : $val',
+        PrintConvInv => '$val eq "n/a" ? 4294965247 : $val',
         Notes => q{
-            this value is used as a key to decrypt other information -- writing this tag
-            causes the other information to be re-encrypted with the new key
+            includes both mechanical and electronic shutter activations for models with
+            this feature.  This value is used as a key to decrypt other information, and
+            writing this tag causes the other information to be re-encrypted with the
+            new key
         },
     },
@@ -1404,11 +2237,22 @@
         {
             Name => 'FlashInfo0103',
-            Condition => '$$valPt =~ /^0103/',
+            # (0104 for D7000, 0105 for D800)
+            Condition => '$$valPt =~ /^010[345]/',
             SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0103' },
         },
-        { #29 (D7000, NC)
-            Name => 'FlashInfo0104',
-            Condition => '$$valPt =~ /^0104/',
-            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0103' },
+        {
+            Name => 'FlashInfo0106', # (Df, D610, D3300, D5300, D7100, Coolpix A)
+            Condition => '$$valPt =~ /^0106/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0106' },
+        },
+        {
+            Name => 'FlashInfo0107', # (0107 for D4S/D750/D810/D5500/D7200, 0108 for D5/D500/D3400)
+            Condition => '$$valPt =~ /^010[78]/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0107' },
+        },
+         {
+            Name => 'FlashInfo0300', # (Z7_2)
+            Condition => '$$valPt =~ /^0300/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Nikon::FlashInfo0300' },
         },
         {
@@ -1422,9 +2266,22 @@
     0x00ac => { Name => 'ImageStabilization',Writable=> 'string' }, #14
     0x00ad => { Name => 'AFResponse',       Writable => 'string' }, #14
-    0x00b0 => { #PH
+    0x00b0 => [{ #PH
         Name => 'MultiExposure',
         Condition => '$$valPt =~ /^0100/',
-        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::MultiExposure' },
-    },
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::MultiExposure',
+            # Note: this endianness varies with model, but Nikon software may change
+            # metadata endianness (although it is unknown how it affects this record),
+            # so for now don't specify ByteOrder although it may be wrong if the
+            # file is rewritten by Nikon software --> see comments for FileInfo
+        },
+    },{
+        Name => 'MultiExposure',
+        Condition => '$$valPt =~ /^0101/',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::MultiExposure',
+            ByteOrder => 'LittleEndian',
+        },
+    }],
     0x00b1 => { #14/PH/JD (D80)
         Name => 'HighISONoiseReduction',
@@ -1434,9 +2291,11 @@
             1 => 'Minimal', # for high ISO (>800) when setting is "Off"
             2 => 'Low',     # Low,Normal,High take effect for ISO > 400
+            3 => 'Medium Low',
             4 => 'Normal',
+            5 => 'Medium High',
             6 => 'High',
         },
     },
-    # 0x00b2 (string: 'Normal', 0xc3's, 0xff's or 0x20's)
+    # 0x00b2 (string: "NORMAL  ", 0xc3's, 0xff's or 0x20's)
     0x00b3 => { #14
         Name => 'ToningEffect',
@@ -1469,7 +2328,32 @@
     0x00b7 => { #JD
         Name => 'AFInfo2',
+        # (this structure may be byte swapped when rewritten by CaptureNX)
         SubDirectory => { TagTable => 'Image::ExifTool::Nikon::AFInfo2' },
     },
-    0x00b8 => { #PH
+    0x00b8 => [{ #PH
+        Name => 'FileInfo',
+        # unfortunately, some newer models write this as little-endian
+        # (and CaptureNX can change the byte order of the maker notes,
+        #  but leaves this structure unchanged)
+        # - it will be an ongoing pain to keep this list of models up-to-date,
+        #   so if only one ordering yields valid DirectoryNumber and FileNumber values,
+        #   use it, otherwise default to a-priori knowledge of the camera model
+        #   (assume that a valid DirectoryNumber is 100-999, and a valid FileNumber
+        #   is 0000-9999, although I have some samples with a DirectoryNumber of 99)
+        Condition => q{
+            if (length($$valPt) >= 0) {
+                my ($dir, $file) = unpack('x6vv', $$valPt);
+                my $littleEndian = ($dir >= 100 and $dir <= 999 and $file <= 9999);
+                ($dir, $file) = unpack('x6nn', $$valPt);
+                my $bigEndian = ($dir >= 100 and $dir <= 999 and $file <= 9999);
+                return $littleEndian if $littleEndian xor $bigEndian;
+            }
+            return $$self{Model} =~ /^NIKON (D4S|D750|D810|D3300|D5200|D5300|D5500|D7100)$/;
+        },
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::FileInfo',
+            ByteOrder => 'LittleEndian',
+        },
+    },{
         Name => 'FileInfo',
         SubDirectory => {
@@ -1477,5 +2361,5 @@
             ByteOrder => 'BigEndian',
         },
-    },
+    }],
     0x00b9 => { #28
         Name => 'AFTune',
@@ -1483,10 +2367,22 @@
     },
     # 0x00ba - custom curve data? (ref 28?) (only in NEF images)
+    0x00bb => { #forum6281
+        Name => 'RetouchInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Nikon::RetouchInfo' },
+    },
+    # 0x00bc - NEFThumbnail? (forum6281)
     0x00bd => { #PH (P6000)
         Name => 'PictureControlData',
         Writable => 'undef',
         Permanent => 0,
-        Binary => 1,
+        Flags => [ 'Binary', 'Protected' ],
         SubDirectory => { TagTable => 'Image::ExifTool::Nikon::PictureControl' },
+    },
+    0x00c3 => {
+        Name => 'BarometerInfo',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nikon::BarometerInfo',
+            # (little-endian in II EXIF, big-endian in MOV)
+        },
     },
     0x0e00 => {
@@ -1505,6 +2401,6 @@
         Writable => 'undef',
         Permanent => 0,
-        Drop => 1, # (may be too large for JPEG images)
-        Binary => 1,
+        # (Drop because may be too large for JPEG images)
+        Flags => [ 'Binary', 'Protected', 'Drop' ],
         Notes => q{
             this data is dropped when copying Nikon MakerNotes since it may be too large
@@ -1521,9 +2417,12 @@
         Name => 'NikonCaptureVersion',
         Writable => 'string',
-        PrintConv => undef,
+        Permanent => 0,
+        PrintConv => undef, # (avoid applying default print conversion to string)
     },
     # 0x0e0e is in D70 Nikon Capture files (not out-of-the-camera D70 files) - PH
     0x0e0e => { #PH
         Name => 'NikonCaptureOffsets',
+        Writable => 'undef',
+        Permanent => 0,
         SubDirectory => {
             TagTable => 'Image::ExifTool::Nikon::CaptureOffsets',
@@ -1541,9 +2440,9 @@
         },
     },
-    0x0e13 => [{ # PH/http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,2737.0.html
+    0x0e13 => [{ # PH/https://exiftool.org/forum/index.php/topic,2737.0.html
         Name => 'NikonCaptureEditVersions',
         Condition => '$self->Options("ExtractEmbedded")',
         Notes => q{
-            the ExtractEmbedded option may be used to decode settings from the stored
+            the L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> option may be used to decode settings from the stored
             edit versions, otherwise this is extracted as a binary data block
         },
@@ -1561,11 +2460,9 @@
         Writable => 'undef',
         Permanent => 0,
-        Binary => 1,
-        Drop => 1,
+        Flags => [ 'Binary', 'Protected', 'Drop' ],
     }],
     0x0e1d => { #JD
         Name => 'NikonICCProfile',
-        Binary => 1,
-        Protected => 1,
+        Flags => [ 'Binary', 'Protected' ],
         Writable => 'undef', # must be defined here so tag will be extracted if specified
         WriteCheck => q{
@@ -1582,5 +2479,5 @@
         Writable => 'undef',
         Permanent => 0,
-        Binary => 1,
+        Flags => [ 'Binary', 'Protected' ],
         SubDirectory => {
             TagTable => 'Image::ExifTool::Nikon::CaptureOutput',
@@ -1596,4 +2493,5 @@
             '0 0 0 0' => 'n/a (JPEG)',
             '8 8 8 0' => '8 x 3', # TIFF RGB
+            '16 16 16 0' => '16 x 3', # TIFF 16-bit RGB
             '12 0 0 0' => 12,
             '14 0 0 0' => 14,
@@ -1683,10 +2581,20 @@
         Name => 'VibrationReduction',
         PrintConv => {
+            0 => 'n/a', # (1V1 with a non-VR lens)
             1 => 'On',
             2 => 'Off',
         },
     },
-    # 5 - values: 0, 1, 2
-    # 6 and 7 - values: 0
+    # 5 - values: 0, 1 (VR On), 2 (VR Off)
+    6 => {
+        Name => 'VRMode',
+        PrintConv => {
+            0 => 'Normal', # (Z7 gives this value for "off" - PH)
+            1 => 'On (1)', #PH (NC)
+            2 => 'Active', # (1J1)
+            3 => 'Sport', #PH (Z7)
+        },
+    },
+    # 7 - values: 0, 1
 );
 
@@ -1804,4 +2712,5 @@
     # Neutral2   03 c2 01 00 02 ff 80 7f 81 00 7f ff ff ff (custom)
     # (note that up to 9 different custom picture controls can be stored)
+    # --> bytes 44 and 45 are swapped if CaptureNX changes the byte order
     #
     48 => { #21
@@ -1897,4 +2806,5 @@
             0x89 => 'Red-purple',
             0xff => 'n/a',
+            # 0x04 - seen for D810 (PH)
         },
     },
